#include <stdio.h>
#include <stdlib.h>

// Attempting to modify a constant pointer to non-constant data

int main()
{
   int x; /* define x */
   int y; /* define y */

   /* ptr is a constant pointer to an integer that can be modified
      through ptr, but ptr always points to the same memory location */
   int * const ptr = &x;

   *ptr = 7; /* allowed: *ptr is not const */
   ptr = &y; /* error: ptr is const; cannot assign new address */

   return 0; /* indicates successful termination */

} /* end main */

// Attempting to modify a constant pointer to constant data.

int ctpCtd()
{
   int x = 5; /* initialize x */
   int y;     /* define y */

   /* ptr is a constant pointer to a constant integer. ptr always
      points to the same location; the integer at that location
      cannot be modified */
   const int *const ptr = &x;

   printf( "%d\n", *ptr );

   *ptr = 7; /* error: *ptr is const; cannot assign new value */
   ptr = &y; /* error: ptr is const; cannot assign new address */

   return 0; /* indicates successful termination */

} /* end ctpCtd */


