/***************************************************************
* Name:         trace.c
*
* Purpose:      Provides trace capability to the program
*
* Course code:  21022105
* Student name: Marius Joldos
* E-mail:       Marius.Joldos@cs.utcluj.ro
****************************************************************
* Created:      2008-04-01
*
****************************************************************/
#include "trace.h"
#include <stdio.h>
#include <stdarg.h>
#include "trace.h"

static FILE *tf = NULL;
static enum bool traceOn = false;

void startTrace()
{
    if (!tf)
    {

        if (NULL == (tf = fopen("Trace.log", "a")))
        {
            fprintf(stderr, "Cannot create Trace.log");
            return;
        }
        traceOn = true;
    }
}
/***********************************************************
* FUNCTION NAME: stopTrace
*
* DESCRIPTION: closes trace file and sets file pointer to NULL
*
* ARGUMENT LIST: none
* RETURN VALUE: void
*
* CHANGES: module variable tf
*************************************************************/
void stopTrace()
{
    if (tf)
    {
        fclose(tf);
        tf = NULL;
    }
    traceOn = false;
}
/***********************************************************
* FUNCTION NAME: trace
*
* DESCRIPTION:  writes a trace specified by printf like list
*               to file Trace.log
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* const char*   fmt      I  printf format specifier
*               ...         things to print
* RETURN VALUE: void
*
* CHANGES: module variable tf
*************************************************************/
void trace(const char *fmt, ...)
{
    va_list ap;

    if (!traceOn) return;
    va_start (ap, fmt);
    vfprintf (tf, fmt, ap);
    fflush(tf);
    va_end (ap);
}
